/**************************************************************************************
SHERICAL SUDOKU PROJECT GAME FILE
Game Name     : Mosaic
Version       : 1.0
Programmer    : Fahri Aydos (www.aydos.net)
First Version : 2006 05 08
Last Version  : 2006 05 08
---------------------------------------------------------------------------------------
Spherical Sudoku Copyright 2006 by Fahri Aydos
http://sudoku.aydos.net - spherical sudoku official website
---------------------------------------------------------------------------------------
This file is freeware...
You may copy, modify, use and distribute this software,
provided that you do not change this header and include it in all such copies.
**************************************************************************************/

/**************************************************************************************
VERSION HISTORY
version 1.0, 2006 05 08
-- rotation of 9 squares
**************************************************************************************/

function start_new_game() {
	var i, r, x, y, z;
	if (gamestat==1)
		return;
	init_table();
	gamestat = 1;
	r = 33;
	for(i=0;i<r;i++) {
		x = Math.floor(Math.random()*10);
		y = Math.floor(Math.random()*10)%9+1;
		z = (Math.floor(Math.random()*10)%3+1)*3;
		if(x%2==0) {
			rotate("r",y,z);
		} else {
			rotate("d",y,z);
		}
	}
	gamestat = 2;
	fill_table();
	return false;
}

function write_table() {
	var i, j;
	document.write('<table class=sdk>');
	for (i=1;i<=9;i++) {
		document.write('<tr>');
		di = i%3?i%3:3;
		for (j=1;j<=9;j++) {
			dj = j%3?j%3:3;
			k = di*3+dj-3;
			document.write('<td class="bdr'+k+'"><input id=box'+i+j+' class=box readonly></td>');
			if((j==3)||(j==6)||(j==9)){
				document.write('<td class=box><input name=btnr'+i+j+' type=image src="r.gif" onclick="btnclick(this);"></td>');
			}
		}
		document.write('</tr>');
		if((i==3)||(i==6)||(i==9)){
			document.write('</tr>');
			for (j=1;j<=9;j++) {
				dj = j%3?j%3:3;
				k = di*3+dj-3;
				document.write('<td class=box><input name=btnd'+j+i+' type=image src="d.gif" onclick="btnclick(this);"></td>');
				if((j==3)||(j==6)||(j==9)){
					document.write('<td>&nbsp;</td>');
				}
			}
			document.write('</tr>');
		}
	}
	document.write('</table>');
}

function rotate(a,b,c) {
	var i;
	if(a=="r"){
		s = sudoku[b][c];
		sudoku[b][c] = sudoku[b][c-1];
		sudoku[b][c-1] = sudoku[b][c-2];
		sudoku[b][c-2] = s;
	}
	if(a=="d"){
		s = sudoku[c][b];
		sudoku[c][b] = sudoku[c-1][b];
		sudoku[c-1][b] = sudoku[c-2][b];
		sudoku[c-2][b] = s;
	}
	fill_table();
}

function btnclick(btn) {
	var a, b, c;
	a = String(btn.name).substring(3,4);
	b = String(btn.name).substring(4,5);
	c = String(btn.name).substring(5,6);
	rotate(a,b,c);
}